routes/web.php
<?php

use App\Http\Controllers\Admin\BookController as AdminBookController;
use App\Http\Controllers\Guest\BookController as GuestBookController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

// Route::get('/', function () {
//     return view('guest.index');
// });

Route::name('guest.')
    ->group(function () {
        // Route::get('/', [GuestBookController::class, 'index']);
        // Route::get('/', function() {
        //     return view('welcome')
        // });
        Route::resource('/books', GuestBookController::class);
    });

Route::middleware(['auth', 'verified'])->prefix('admin')->name('admin.')->group(function () {
    Route::get('/dashboard', [DashboardController::class, 'index'])->name('dashboard');
    Route::post('/books/search', [AdminBookController::class, "search"])->name("search");
    Route::get('/books/trashed', [AdminBookController::class, 'trashed'])->name('trashed');
    Route::get('/books/{id}/restore', [AdminBookController::class, 'restore'])->name('restore');
    Route::delete('/books/{id}/force-delete', [AdminBookController::class, 'forceDelete'])->name('forceDelete');
    Route::resource('/books', AdminBookController::class);
});

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__ . '/auth.php';

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Book extends Model
{
    use HasFactory;
    use SoftDeletes;

    protected $fillable = [
        'isbn_13',// nella validation mettiamo una limitazione sui numero dei caratteri : esattamente 13
        /**
         * attenzione che il title e series non sono unique e lo slug dovrà avere un contatore (es. zanna-bianca-2')
         * si può creare lo slug
         * fare una query (where 'slug' = $slugAppenaCreato)
         * se la query ci restituisce qualcosa
         * $slugAppenaCreato .= count($slugTrovatiNellaQuery)
         */
        // 'slug', 
        'title',
        'series',
        'author',
        'publisher',
        'publication_date',
        'plot',
        'genre',
        'cover_image',
    ];

    //per poter mostrare il dato con un formato specifico, vedi in guest.books.index il '->format(Y)'
    protected $dates = [
        'publication_date',
    ];

    public function author(){
        return $this->belongsTo(Author::class);
    }

    public function user(){
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/Admin/BookController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Book;
use Illuminate\Validation\Rule;

class BookController extends Controller
{
    protected $rules = [
        'isbn_13' => 'required|unique:books|size:13|string',
        'title' => 'required|string|min:2|max:80',
        'series' => 'required|string|min:2|max:50',
        'author' => 'required|string|min:2|max:100|regex:/^[a-zA-Z .,]+$/',
        'publisher' => 'required|string|min:2|max:80',
        'publication_date' => 'required|date|after_or_equal:\'1450-01-01\'|before_or_equal:today',
        'plot' => 'required|string|min:15|max:65535',
        'genre' => 'required|string|min:2|max:40',
        'cover_image' => 'required|image|max:6000'
    ];

    protected $errorMessages = [
        'isbn_13.required' => 'Il codice ISBN è necessario.',
        'isbn_13.unique' => 'Il codice ISBN non può essere uguale ad un altro codice ISBN in archivio.',
        'isbn_13.size' => 'Il codice ISBN deve essere lungo 13 caratteri.',
        'isbn_13.string' => 'Il codice ISBN deve essere una stringa.',


        'title.required' => 'Il titolo è necessario.',
        'title.string' => 'Il titolo deve essere una stringa.',
        'title.min' => 'Il titolo deve essere lungo almeno 2 caratteri.',
        'title.max' => 'Il titolo non può superare i 70 caratteri.',

        'series.required' => 'La serie di appartenenza è necessaria.',
        'series.min' => 'Il nome della serie di appartenenza deve essere lungo almeno 2 caratteri.',
        'series.max' => 'Il nome della serie di appartenenza non può superare i 50 caratteri.',
        'series.string' => 'Il nome della serie di appartenenza deve essere una stringa.',

        'author.required' => 'L\'autore è necessario.',
        'author.string' => 'Il nome dell\'autore deve essere una stringa.',
        'author.min' => 'Il nome dell\'autore deve essere lungo almeno 2 caratteri.',
        'author.max' => 'Il nome dell\'autore non può superare i 100 caratteri.',

        'publisher.required' => 'La casa produttrice è necessaria.',
        'publisher.string' => 'Il nome della casa produttrice deve essere una stringa.',
        'publisher.min' => 'Il nome della casa produttrice deve essere lungo almeno 2 caratteri.',
        'publisher.max' => 'Il nome della casa produttrice non può superare gli 80 caratteri.',

        'publication_date.required' => 'La data di pubblicazione è necessaria.',
        'publication_date.integer' => 'La data di pubblicazione deve essere espressa in numeri interi.',
        'publication_date.between' => 'La data di pubblicazione deve essere compresa tra il 01/01/1450 e il 27/02/2023',

        'plot.required' => 'La trama è necessaria.',
        'plot.string' => 'La trama deve essere una stringa.',
        'plot.min' => 'La trama deve essere lunga almeno 15 caratteri.',
        'plot.max' => 'La trama non può superare i 65535 caratteri.',

        'genre.required' => 'Il genere è necessario.',
        'genre.string' => 'Il genere deve essere una stringa.',
        'genre.min' => 'Il genere deve essere lungo almeno 2 caratteri.',
        'genre.max' => 'Il genere non può superare i 40 caratteri.',

        'cover_image.required' => 'L\'immagine è necessaria.',
        'cover_image.image' => 'Il file caricato deve essere un\'immagine.',
        'cover_image.max' => 'L\'immagine è troppo grande. (max: 6000kb)',

    ];

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $books = Book::orderBy('id')->paginate(15);
        return view('admin.books.index', compact('books'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.books.create', ['book' => new Book()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = $this->rules;
        $errorMessage = $this->errorMessages;
        $data = $request->validate($rules, $errorMessage);

        $newBook = new Book();
        $newBook->fill($data);
        $newBook->save();

        return redirect()->route('admin.books.show', $newBook->id)->with('message', "$newBook->title è stato creato con successo")->with('alert->type', 'success');
    }

    /**
     * Display the specified resource.
     *
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        $previousBook = Book::where('id', '<', $book->id)->orderBy('id', 'DESC')->first();
        $nextBook = Book::where('id', '>', $book->id)->orderBy('id')->first();
        return view('admin.books.show', compact('book', 'previousBook', 'nextBook'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        return view("admin.books.edit", compact("book"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        $rules = $this->rules;
        $errorMessage = $this->errorMessages;
        $rules['isbn_13'] = ['required', 'size:13', 'string', Rule::unique('books')->ignore($book->id)];
        $data = $request->validate($rules, $errorMessage);

        $book->update($data);

        redirect()->route('admin.books.show', compact('book'));


        return redirect()->route('admin.books.show', compact('book'));
    }

    /**
     * Soft delete the specified resource from storage.
     *
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        $book->delete();

        return redirect()->route('admin.books.index')->with('message', "$book->title è stato eliminato con successo")->with('alert->type', 'warning');
    }

    /**
     * Display a listing of trash.
     *
     * @return \Illuminate\Http\Response
     */
    public function trashed()
    {
        $trashedBooks = Book::onlyTrashed()->get();
        return view('admin.books.trashed', compact('trashedBooks'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */

    public function forceDelete($id)
    {
        // keep forceDelete title
        $book = Book::onlyTrashed()->where('id', $id)->first();
        $titleRestoreBook = $book->title;

        Book::where("id", $id)->withTrashed()->forceDelete();
        return redirect()->route('admin.trashed')->with("message", "$titleRestoreBook è stato cancellato definitivamente")->with("alert-type", "warning");;
    }

    /**
     * Restore the specified resource from soft delete.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */

    public function restore($id)
    {
        // keep restore title
        $book = Book::onlyTrashed()->where('id', $id)->first();
        $titleRestoreBook = $book->title;

        Book::where("id", $id)->withTrashed()->restore();

        return redirect()->route('admin.trashed')->with("message", "$titleRestoreBook è stato ripristinato")->with("alert-type", "success");;
    }

    /**
     * search filter by title
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function search(Request $request)
    {
        $books = Book::where('title', 'LIKE', "$request->search.%")->get();
        return view('admin.books.index', compact('books'));
    }
}

app/Http/Controllers/Api/BookController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Book;
use Illuminate\Http\Request;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $books = Book::paginate(25);

        return response()->json([
            'success' => true,
            'results' => $books,
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return response()->json([
            'success' => true,
            'results' => $book,
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Guest/BookController.php
<?php

namespace App\Http\Controllers\Guest;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Book;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $books= Book::paginate(16);
        return view('guest.books.index', compact('books'));
    }

    /**
     * Display the specified resource.
     *
     * @param  Book $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return view('guest.books.show', compact('book'));
    }
}

resources/views/admin/books/create.blade.php
{{-- 
|--------------------------------------------------------------------------
| Project create in Admin
|--------------------------------------------------------------------------
|
| This is the create 'Project' section of the website
| available to the Admin.
|
--}}
@extends('layouts.app')

@section('pageTitle' , "My favorite Books store - create a book record")

@section('content')
@include('admin.books.partials.editCreate',["route" => "admin.books.store"  , "formMethod" => "POST" ])
@endsection

resources/views/admin/books/edit.blade.php
{{-- 
|--------------------------------------------------------------------------
| Project edit in Admin
|--------------------------------------------------------------------------
|
| This is the edit 'Project' section of the website
| available to the Admin.
|
--}}
@extends('layouts.app')

@section('pageTitle' , 'My favorite Books store - book modify')

@section('content')
@include('admin.books.partials.editCreate',["route" => "admin.books.update"  , "formMethod" => "PUT" ])    
@endsection

resources/views/admin/books/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container py-5">
    <div class="row">
        <div class="col-12">
            @if (session('message'))
                <div class="alert alert-{{ session('message_class') }} mb-3">
                    {{ session('message') }}
                </div>
            @endif
        </div>
        <div class="col-12">
            <a href="{{route('admin.books.create')}}" class="btn btn-success">
                Create new book
            </a>
            <a href="{{route('admin.trashed')}}" class="btn btn-warning">
                Trash
            </a>
        </div>
        <div class="col-12">
            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">id</th>
                        <th scope="col">title</th>
                        <th scope="col">author</th>

                        <th scope="col">actions</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($books as $book)
                        <tr>
                            <th scope="row">{{ $book->id }}</th>
                            <td>{{ $book->title }}</td>
                            <td>{{ $book->author }}</td>

                            <td>
                                <div class="actionButtons d-flex">
                                    <a href="{{route('admin.books.show', $book->id)}}" class="btn btn-sm btn-primary">Show</a>
                                    <a href="{{route('admin.books.edit', $book->id)}}" class="btn btn-sm btn-warning mx-2">Edit</a>
                                    <form action="{{route('admin.books.destroy', $book->id)}}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-sm btn-danger">
                                            Delete
                                        </button>
                                    </form>
                                </div>
                            </td>

                        </tr>
                    @endforeach
                    
                </tbody>
            </table>
            {{-- {{ $books->links() }} --}}
        </div>
    </div>
    {{$books->links()}}
</div>
@endsection

resources/views/admin/books/show.blade.php
@extends('layouts.app')

@section('content')
<div class="container py-5">
    <div class="row justify-content-between">
        <div class="col-12">
            <div class="card text-center mb-4">
                <div class="card-header">
                    <h3>{{$book->title}}</h3>
                </div>
                <div class="row card-body text-start">
                    <div class="col-7 card-text">
                        <h5>{{$book->series}}</h5>
                        <ul>
                            <li><span class="text-secondary font-weight-bold">author: </span>{{$book->author}}</li>
                            <li><span class="text-secondary font-weight-bold">plot: </span>{{$book->plot}}</li>
                            <li><span class="text-secondary font-weight-bold">publisher: </span>{{$book->publisher}}</li>
                            <li><span class="text-secondary font-weight-bold">publication date: </span>{{$book->publication_date}}</li>
                            <li><span class="text-secondary font-weight-bold">genre: </span>{{$book->genre}}</li>
                        </ul>
                    </div>
                    <div class="col-5 bg-dark px-3">
                        {{--@if ( str_starts_with($book->cover_image, 'http'))
                            <img src="{{ $book->cover_image }}" alt="book image" class="img-fluid">
                        @else
                            <img src="{{ asset('storage/' . $book->cover_image) }}" alt="book image" class="img-fluid">
                        @endif--}}
                    </div>
                </div>

                <div class="row col-4 ms-auto me-3 my-3">
                    <div class="col-6 homeButtonContainer text-center">
                        <a href="{{route('admin.books.index')}}" class="btn btn-sm btn-primary">Back to the list</a>
                    </div>
                    <div class="col-3 homeButtonContainer text-center">
                        <a href="{{route('admin.books.edit', $book->id)}}" class="btn btn-sm btn-warning">Edit</a>
                    </div>
                    <div class="col-3 homeButtonContainer text-center">
                        <form action="{{route('admin.books.destroy', $book->id)}}" method="POST">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-sm btn-danger">
                                Delete
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
        @if (isset($previousBook))
            <div class="col-2">
                <a class="btn btn-outline-primary" href="{{route('admin.books.show',$previousBook->id)}}">previous</a>
            </div>
        @else
            <div class="col-2">
                <a class="btn btn-outline-secondary disabled" href="">previous</a>
            </div>
        @endif

        @if (isset($nextBook))
            <div class="col-2">
                <a class="btn btn-outline-primary" href="{{route('admin.books.show',$nextBook->id)}}">next</a>
            </div>
        @else
            <div class="col-2">
                <a class="btn btn-outline-secondary disabled" href="">next</a>
            </div>
        @endif
    </div>
</div>
@endsection

resources/views/admin/books/trashed.blade.php
@extends('layouts.app')

@section('content')
<div class="container py-5">
    <div class="row">
        <div class="col-12">
            @if (session('message'))
                <div class="alert alert-{{ session('message_class') }} mb-3">
                    {{ session('message') }}
                </div>
            @endif
        </div>
        <div class="col-12">
            <a href="{{route('admin.books.index')}}" class="btn btn-success">
                Back to book table
            </a>
        </div>
        <div class="col-12">
            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">id</th>
                        <th scope="col">title</th>
                        <th scope="col">author</th>

                        <th scope="col">actions</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($trashedBooks as $book)
                        <tr>
                            <th scope="row">{{ $book->id }}</th>
                            <td>{{ $book->title }}</td>
                            <td>{{ $book->author }}</td>

                            <td>
                                <div class="actionButtons d-flex">
                                    <a href="{{ route('admin.restore', $book->id) }}" class="btn btn-sm btn-success">Restore</a>
                                    <form action="{{route('admin.forceDelete', $book->id)}}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-sm btn-danger">
                                            Delete
                                        </button>
                                    </form>
                                </div>
                            </td>

                        </tr>
                    @endforeach
                    
                </tbody>
            </table>
            {{-- {{ $books->links() }} --}}
        </div>
    </div>
</div>
@endsection